;BatSaver.asm by AJD	Anthony Doggett, Doggett@zetnet.co.uk
;Version 01		03 Mar 98
;Based on TestInt.asm
;Sets the period which the calculator waits before switching off to the value given
; in the constant "offtime".  Thus, calculator powers off normally, thus the status
; is saved (eg. if you leave it in the stats editor, it'll be in the stats editor when
; you switch on again).
;Use the program "Remove" to remove this interrupt.

#include "asm86.h"
#include "ti86asm.inc"

_user_int_ram 	EQU	$d2fd
offtime	equ	20			;30 is roughly 45 seconds

.org _asm_exec_ram
	res 2,	(iy+$23)		;Turn user int off so it won't get called by
					; accident before we're ready
	ld hl,	int			;Copy prog to user int buffer
	ld de,	_user_int_ram+1
	ld bc,	int_end-int		;Length of handler
	ldir
	;Set up checksum byte:
	ld a,	(_user_int_ram+1)
	ld hl,	_user_int_ram+($28*1)	;load byte
	add a,	(hl)			;Add to total
	ld hl,	_user_int_ram+($28*2)	;Load byte
	add a,	(hl)			;Add to total
	ld hl,	_user_int_ram+($28*3)	;Load byte
	add a,	(hl)			;Add to total
	ld hl,	_user_int_ram+($28*4)	;Load byte
	add a,	(hl)			;Add to total
	ld hl,	_user_int_ram+($28*5)	;Load byte
	add a,	(hl)			;Add to total
	ld (_user_int_ram),a		;Load checksum in its location

	set 2,	(iy+$23)			;Turn user interrupt on
	ret

int:
	ld	hl,	$c00a		;Point hl to countdown timer
	ld	a,	(hl)
	cp	offtime+1		;Compare to critical value
	ret	c			;Return if countdown timer is less
	ld	(hl),	offtime		;Otherwise set countdown timer to our number
	ret				;Return
int_end:
.end


